package org.openxma.dsl.platform.dao;

import org.openxma.dsl.platform.dao.impl.JoinExpression;
import org.openxma.dsl.platform.dao.impl.ResultLimitExpression;
import org.openxma.dsl.platform.dao.impl.ComparisonExpression.EqualsExpression;
import org.openxma.dsl.platform.dao.impl.ComparisonExpression.GreaterThanExpression;
import org.openxma.dsl.platform.dao.impl.ComparisonExpression.GreaterThanOrEqualsExpression;
import org.openxma.dsl.platform.dao.impl.ComparisonExpression.LessThanExpression;
import org.openxma.dsl.platform.dao.impl.ComparisonExpression.LessThanOrEqualsExpression;
import org.openxma.dsl.platform.dao.impl.ComparisonExpression.LikeExpression;
import org.openxma.dsl.platform.dao.impl.CompositeExpression.AndExpression;
import org.openxma.dsl.platform.dao.impl.CompositeExpression.OrExpression;
import org.openxma.dsl.platform.dao.impl.UnaryExpression.NotExpression;

/**
 * Strategy interface for 'filterable' objects with a visitor like API to 
 * separate the respective algorithm from the <code>FilterSpecifications</code> hierarchy.
 */
public interface Filterable {

	Object append(LessThanExpression lessThanExpression);

	Object append(ResultLimitExpression limitFilterExpression);

	Object append(EqualsExpression equalsExpression);

	Object append(NotExpression notExpression);

	Object append(AndExpression andExpression);

	Object append(OrExpression orExpression);

	Object append(JoinExpression joinExpression);

	Object append(GreaterThanExpression greaterThanExpression);

	Object append(LikeExpression likeExpression);

	Object append(GreaterThanOrEqualsExpression greaterThanOrEqualsExpression);

	Object append(LessThanOrEqualsExpression lessThanOrEqualsExpression);

}
