/*******************************************************************************
 * Copyright (c) 2010 s IT Solutions AT Spardat GmbH .
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     s IT Solutions AT Spardat GmbH - initial API and implementation
 *******************************************************************************/
package org.openxma.dsl.platform.query.impl;

import org.openxma.dsl.platform.query.Expression;
import org.openxma.dsl.platform.query.QueryContext;

/**
 * An expression for parameter values.
 */
public class ParameterExpression extends Expression {
    private static final long serialVersionUID = 1L;
    private String name;

    public ParameterExpression(Expression parent, String name) {
        super(parent);
        this.name = name;
    }

    public String getName() {
        return name;
    }

    public Object evaluate(QueryContext queryContext) {
        return queryContext.accept(this);
    }

    @Override
    public String toString() {
        return name;
    }

}
